/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the AssetTemplateData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AssetTemplateData{}

// AssetTemplateData struct for AssetTemplateData
type AssetTemplateData struct {
	Id string `json:"id"`
	Status string `json:"status"`
}

// NewAssetTemplateData instantiates a new AssetTemplateData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAssetTemplateData(id string, status string) *AssetTemplateData {
	this := AssetTemplateData{}
	this.Id = id
	this.Status = status
	return &this
}

// NewAssetTemplateDataWithDefaults instantiates a new AssetTemplateData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAssetTemplateDataWithDefaults() *AssetTemplateData {
	this := AssetTemplateData{}
	return &this
}

// GetId returns the Id field value
func (o *AssetTemplateData) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *AssetTemplateData) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *AssetTemplateData) SetId(v string) {
	o.Id = v
}

// GetStatus returns the Status field value
func (o *AssetTemplateData) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *AssetTemplateData) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *AssetTemplateData) SetStatus(v string) {
	o.Status = v
}

func (o AssetTemplateData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AssetTemplateData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["status"] = o.Status
	return toSerialize, nil
}

type NullableAssetTemplateData struct {
	value *AssetTemplateData
	isSet bool
}

func (v NullableAssetTemplateData) Get() *AssetTemplateData {
	return v.value
}

func (v *NullableAssetTemplateData) Set(val *AssetTemplateData) {
	v.value = val
	v.isSet = true
}

func (v NullableAssetTemplateData) IsSet() bool {
	return v.isSet
}

func (v *NullableAssetTemplateData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAssetTemplateData(val *AssetTemplateData) *NullableAssetTemplateData {
	return &NullableAssetTemplateData{value: val, isSet: true}
}

func (v NullableAssetTemplateData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAssetTemplateData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


